import theano
import numpy
import cPickle
import datetime
import show
import sys
import conv3d2d
import down3d

def get_network(fn):
  f=file(fn,'rb')
  perform = "none"
  while True:
	try:
		o = cPickle.load(f)
		perform = o
	except:
		break		
  f.close()
  perform.name = 'perform'
  return perform

def save_output2d(network, inputfile, outputfile, 
                  batchsize = 2, inputsize = 32, inputs = 1):
    print "loading data"
    inputmodule = __import__(inputfile);
    faces = inputmodule.get_faces()
    data = faces[0][0][0:batchsize] #trainset, data,
    data = data.reshape((batchsize, inputsize * inputsize))
    labels = faces[0][1] #trainset, labels
    print "processing"
    result = network(data)
    result = map(lambda i: i[0:inputs], result)
    print "saving output to ", outputfile
    F=open(outputfile,"w")
    show.save(F, [[[result], labels]])
    F.close()

def save_output3d(network, inputfile, outputfile, 
                  batchsize = 2, inputs = 1):
    print "loading data"
    inputmodule = __import__(inputfile);
    faces = inputmodule.get_faces()
    data = faces[0][0][0:batchsize] #trainset, data,
    inputsize = data.shape[1]
    data = data.reshape((batchsize, inputsize, inputsize * inputsize))
    labels = faces[0][1] #trainset, labels
    print "processing"
    result = network(data)
    result = map(lambda i: i[0:inputs], result)
    print "saving output to ", outputfile
    F=open(outputfile,"w")
    show.save(F, [[[result], labels]])
    F.close()

try:
 if __name__ == "__main__":
    print "loading network"
    method = sys.argv[1]
    net = get_network(sys.argv[2])
    input = sys.argv[3]    
    if method == "2d":    		
      save_output2d(net, input, input + ".out")
    if method == "3d":    		
      save_output3d(net, input, input + ".out")
except:
 print sys.exc_info()
 raw_input("Error. Press enter")